using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

//---------------------------------------------------------------------------

namespace EfromTibet {
  public class Snowman : StaticActor {
    public const int STATE_THERE = 0;
    
    //protected const int GRID_WIDTH = 200;
    //protected const int GRID_HEIGHT = 768 / 3;
    //protected const int CELLS_WIDE = 10;
    
    public const int PERCENT_COURSE_PER_SNOWMAN = 16;
    protected const int NUM_SNOWMAN = 6;

    // array of textures
    protected Texture2D[] m_textures = new Texture2D[NUM_SNOWMAN];

    public Snowman(): base() {

    }

    public override int state {
      get {
        return m_state;
      }
      set {
        if (value == STATE_THERE){ // can't be anything else
          m_state = value;  
        }
      }
    }

    public override bool initialize(ContentManager c) {
      try {
        for (int i = 0; i < m_textures.Length; i++) {
          m_textures[i] = c.Load<Texture2D>("SM" + (i+1));
        }

        m_imgSize.Width = m_textures[0].Width;
        m_imgSize.Height = m_textures[0].Height;

        m_objectSize.X = m_imgSize.Width*3;
        m_objectSize.Y = m_imgSize.Height*3;
        m_objectSize.Z = m_imgSize.Width;

        m_collisionSize.X = m_objectSize.X / 2.2f;
        m_collisionSize.Y = m_objectSize.Y;
        m_collisionSize.Z = m_objectSize.Z;


        pos.X = 0;
        pos.Y = 0;
        pos.Z = 0;

        m_state = STATE_THERE;
        return true;
      } catch {
        return false;
      }
    }

    public override bool animate(GameTime gameTime) {
      return false;
    }

    public override bool draw(SpriteBatch spriteHandler, Rectangle? dest) {
      if (dest != null) {
        int percentCourse = 100 * (int)pos.Z / PlayEngineHandler.COURSE_MAX_Z;
        int snowmanNum = (int)((float)percentCourse / PERCENT_COURSE_PER_SNOWMAN + 0.5);
        snowmanNum--;
        if (snowmanNum < 0) {
          snowmanNum = 0;
        }
        if (snowmanNum >= NUM_SNOWMAN) {
          snowmanNum = NUM_SNOWMAN - 1;
        }
        
        //int row = cellNum / CELLS_WIDE;
        //int col = cellNum % CELLS_WIDE;

        //Rectangle src;
        //src.X = col * GRID_WIDTH;
        //src.Y = row * GRID_HEIGHT;
        //src.Width = GRID_WIDTH;
        //src.Height = GRID_HEIGHT;

        spriteHandler.Draw(m_textures[snowmanNum], (Rectangle)dest, null, Color.White);
        return true;
      } else {
        return false;
      }
    }


  }
}

//---------------------------------------------------------------------------
