using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

//---------------------------------------------------------------------------

namespace EfromTibet {
  public abstract class StaticActor : Actor {
    protected Texture2D m_texture;

    // true if we can "ride over" this object with the player
    protected bool m_rideOver;
    public bool rideOver { get { return m_rideOver; } }

    protected bool m_collide;
    public bool canCollide { get { return m_collide; } }

    public StaticActor() : base(){
      m_rideOver = false;
      m_collide = true;
    }

    public override bool draw(SpriteBatch spriteHandler, Rectangle? dest) {
      if (dest != null) {
        spriteHandler.Draw(m_texture, (Rectangle)dest, null, Color.White);
        return true;
      }else{
        return false;
      }
    }

    // NOTE:  The current engine code does not call Animate() for static actors generated for the course.
  }
}

//---------------------------------------------------------------------------
