// OpenCVWrapper.h

#include <cv.h>
#include <highgui.h>


#pragma once

using namespace System;

namespace OpenCVWrapper {

	public ref class OCVWrap{
    protected:
      const static int MAX_FACES = 15;

      const static int CASCADE_NAME_LEN = 2048;
      const static char* const CASCADE_NAME = "haarcascade_frontalface_alt2.xml"; // this is a dummy
      CvCapture** camera;
      CvHaarClassifierCascade* cascade;
      CvMemStorage* storage;
      
      int m_width;
      int m_height;

      int m_numFaces;

      int* m_lastX;
      int* m_lastY;
      int* m_lastWidth;
      int* m_lastHeight;



    public:
      OCVWrap(){
        m_lastX = new int[MAX_FACES];
        m_lastY = new int[MAX_FACES];
        m_lastWidth = new int[MAX_FACES];
        m_lastHeight = new int[MAX_FACES];
      }
      
      bool initialize();
      bool pollFaceCoordinates();

      void deinitialize();

      int getNumFaces();
      int getX(int fID);
      int getY(int fID);
      int getWidth(int fID);
      int getHeight(int fID);

      int getCameraWidth(){ return m_width; }
      int getCameraHeight(){ return m_height; }
	};
}
